{% extends "layouts/base.html" %}
{% block pageJS %}
<script>
    const memory = {};

    window.addEventListener("DOMContentLoaded", function(event) {
        const qrcode = document.getElementById("qr-code");
        const button = document.getElementById("generate-qr-code");
        button.addEventListener("click", async function (event) {
            //  TODO??
            const response = await fetch("http://localhost:5000/payment/request/5000");
            if (response.status != 200) {
                alert(`Shit!!!!, ${response.status}`);
            }
            else {
                const content = await response.json();
                const code    = content.qr_code;
                qrcode.src    = `data:image/*; base64, ${code}`;
                delete content.qr_code;
                memory.since  = new Date().getTime();
                memory.handle = setInterval(() => { query(content); }, 1500);
            }
        });
    });

    async function query(payload) {
        const response = await fetch("http://localhost:5000/payment/query", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            },
            body:   JSON.stringify(payload)
        });
        if (response.status != 200) {
            alert(`Shit!!!!, ${response.status}`);
        }
        else {
            const content = await response.json();
            if (content.response_code == "00") {
                //  TODO:
                //  Show a green tick, payment success... redirect in 5 seconds
                console.log("Paid");
                clearInterval(memory.handle);
                alert("Thank you for paying");
            }
            else if (content.response_code == "09") {
                //  TODO:
                //  Show spining circle
                console.log("Waiting");

                //  IF > 10 seconds, Cancel
                const now = new Date().getTime();
                if (now - memory.since > 10000) {
                    cancel(payload);
                }
            }
            else {
                //  TODO:
                //  Show red cross, Retry
                console.log("Invalidated");
                clearInterval(memory.handle);
                alert("Payment failed. Code not valid anymore");
            }
        }
    }

    async function cancel(payload) {
        const response = await fetch("http://localhost:5000/payment/void", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            },
            body:   JSON.stringify(payload)
        });
        if (response.status != 200) {
            alert(`Shit!!!!, ${response.status}`);
        }
        else {
            const content = await response.json();
            if (content.response_code == "00") {
                console.log("Transaction is cancelled");
            }
            else {
                console.log("Nothing happens", content);
            }
        }
    }

</script>
{% endblock pageJS %}
{% block pageContent %}
<div class="container">
    <button id="generate-qr-code">Click Here</button>
    <img    src="" id="qr-code">
</div>

{% endblock pageContent %}